#
# Copyright © 2020 MSC.Software Corporation
#  
# Permission to use Scripts
#  
# Permission is granted to MSC.Software customers with valid licenses of the MSC Apex™ software 
# to use script files posted on this page (collectively “Scripts”) solely for customers’ own authorized 
# internal use in conjunction with licensed use of the MSC Apex software.  
# No other use is permitted.  No license to MSC Apex or other software is granted under this Permission.
#  
# SCRIPTS ARE PROVIDED ON AN "AS-IS" BASIS, WITH NO WARRANTIES OF ANY KIND.  USE OF THE SCRIPTS IS AT CUSTOMER'S SOLE RISK.
#  
# IN NO EVENT SHALL MSC.SOFTWARE CORPORATION, ITS AFFILIATES, SUBSIDIARIES, SUPPLIERS, AGENTS, REPRESENTATIVES OR EMPLOYEES BE LIABLE FOR ANY 
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL OR CONSEQUENTIAL DAMAGES HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, TORT, 
# STRICT LIABILITY, OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION USE OF THE SCRIPTS, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  
#  
# Customer shall indemnify, defend and hold MSC.Software Corporation, its affiliates, subsidiaries, suppliers, agents, 
# employees or representatives (collectively, “Indemnified Parties”) harmless from and against any third-party claims 
# brought against Indemnified Parties rising out of or in connection with Customer’s use of the Scripts.
#
# Author: Larry Pearce
# Revised by: Larry Pearce
# Revision History
# Date         Change                                 By
# 2020-10-13   Original code                          Larry Pearce

import os
import apex_sdk

# .NET references
import System
import System.Windows.Controls as WPFControls


# setting pre-defined properties of tool_propertyContainer
def getUIContent():
    my_toolProperty = apex_sdk.ToolPropertyContainer()

    my_toolProperty.TitleText = "Update Flexible Links 1.1"

    file_path = os.path.dirname(os.path.realpath(__file__))
    my_toolProperty.TitleImageUriString = file_path+"../res/auUpdateFlexibleLinks.png"

    my_toolProperty.WorkFlowInstructions = """<HTML><BODY><P STYLE=\"font-size:10;\"><SPAN>Updates diameter and/or material for flexible connectors</SPAN></P>
    <P><SPAN> </SPAN></P>
    <P STYLE=\"font-size:10;\"><SPAN>Send questions, comments and Elvis sightings to larry.pearce@mscsoftware.com</SPAN></P></BODY></HTML>"""

    # handle apply button (green) click event
    my_toolProperty.AppliedCommand = apex_sdk.ActionCommand(System.Action(HandleApplyButton))
    # handle exit button (red) click event
    my_toolProperty.ExitCommand = apex_sdk.ActionCommand(System.Action(HandleExitButton))

    my_toolProperty.ToolPropertyContent = getCustomToolPropertyContent()

    # define pickFiterTools
    my_toolProperty.ShowPickChoice = True
    my_toolProperty.IsCustomTool = True
    # setPickFilterTools()
    my_toolProperty.PickFilterList = setPickFilterTools()

    return my_toolProperty


def getCustomToolPropertyContent():

    my_Grid = WPFControls.Grid()

    createLayout(my_Grid, 6, 2)

    iRow = 0
    iCol = 0

    global updateMaterialToggle
    global updateDiameterToggle

    global matlComboBox, matlComboTextBlock
    global diameterTextBox, diameterTextBlock

    updateMaterialToggle = createCheckBox(my_Grid, "Update Material", iRow, iCol)
    iRow += 1

    updateMaterialToggle.Checked   += matlHandleCheck
    updateMaterialToggle.Unchecked += matlHandleUnCheck

    updateDiameterToggle =  createCheckBox(my_Grid, "Update Diameter", iRow, iCol)
    iRow += 1

    updateDiameterToggle.Checked   += diameterHandleCheck
    updateDiameterToggle.Unchecked += diameterHandleUnCheck

    matlComboTextBlock = createTextBlock(my_Grid, "New Material:", iRow, iCol)
    matlComboBox       = createComboBox(my_Grid, iRow, iCol+1)
    iRow += 1

    file_path = os.path.dirname(os.path.realpath(__file__))
    script_path = os.path.join(file_path, './auGetMaterials.py')
    apex_sdk.runScriptFunction(script_path, "main", callback=getMatls)

    diameterTextBlock = createTextBlock(my_Grid, "New Diameter:", iRow, iCol)
    diameterTextBox   = createTextBox(my_Grid,   "",              iRow, iCol+1)
    iRow += 1

    matlComboTextBlock.Visibility = System.Windows.Visibility.Collapsed
    matlComboBox.Visibility = System.Windows.Visibility.Collapsed

    diameterTextBlock.Visibility = System.Windows.Visibility.Collapsed
    diameterTextBox.Visibility = System.Windows.Visibility.Collapsed

    return my_Grid


def matlHandleCheck(sender, event):
    global matlComboTextBlock, matlComboBox

    matlComboTextBlock.Visibility = System.Windows.Visibility.Visible
    matlComboBox.Visibility   = System.Windows.Visibility.Visible


def matlHandleUnCheck(sender, event):
    global matlComboTextBlock, matlComboBox

    matlComboTextBlock.Visibility = System.Windows.Visibility.Collapsed
    matlComboBox.Visibility = System.Windows.Visibility.Collapsed


def diameterHandleCheck(sender, event):
    global diameterTextBlock, diameterTextBox

    diameterTextBlock.Visibility = System.Windows.Visibility.Visible
    diameterTextBox.Visibility = System.Windows.Visibility.Visible


def diameterHandleUnCheck(sender, event):
    global diameterTextBlock, diameterTextBox

    diameterTextBlock.Visibility = System.Windows.Visibility.Collapsed
    diameterTextBox.Visibility = System.Windows.Visibility.Collapsed


def createCheckBox(parent, label, row, col):

    checkBox = WPFControls.CheckBox()
    checkBox.Content = label
    checkBox.Margin = System.Windows.Thickness(5.)

    WPFControls.Grid.SetRow(checkBox, row)
    WPFControls.Grid.SetColumn(checkBox, col)

    parent.Children.Add(checkBox)

    return checkBox


def createLayout(parent, numRows, numCols):
    for k in range(numRows):
        parent.RowDefinitions.Add(WPFControls.RowDefinition())
    for k in range(numCols):
        parent.ColumnDefinitions.Add(WPFControls.ColumnDefinition())


def createComboBox(parent, row, col):
    comboBox = WPFControls.ComboBox()

    comboBox.Margin = System.Windows.Thickness(5.)

    WPFControls.Grid.SetRow(comboBox, row)
    WPFControls.Grid.SetColumn(comboBox, col)

    parent.Children.Add(comboBox)

    return comboBox


def updateComboBox(comboBox, comboItems):

    for comboItem in comboItems:
        item = WPFControls.ComboBoxItem()
        item.Content=comboItem
        comboBox.Items.Add(item)

    comboBox.SelectedIndex="0"


def createTextBlock(parent, text, row, col):
    textBlock = WPFControls.TextBlock()
    textBlock.Text = text

    textBlock.Margin = System.Windows.Thickness(5.)

    WPFControls.Grid.SetRow(textBlock, row)
    WPFControls.Grid.SetColumn(textBlock, col)
    parent.Children.Add(textBlock)

    return textBlock


def createTextBox(parent, value, row, col):
    textBox =WPFControls.TextBox()

    textBox.Margin = System.Windows.Thickness(5.)

    WPFControls.Grid.SetRow(textBox, row)
    WPFControls.Grid.SetColumn(textBox, col)
    textBox.Text=value

    parent.Children.Add(textBox)

    return textBox


# set pickFilers
# some pick choices are commented out
def setPickFilterTools():
    pickChoices = System.Collections.Generic.List[System.String]()

    # exclusive picking and visibility picking
    pickChoices.Add(apex_sdk.PickFilterTypes.ExclusivePicking)
    pickChoices.Add(apex_sdk.PickFilterTypes.VisibilityPicking)

    pickChoices.Add(apex_sdk.PickFilterTypes.Connector)

    return pickChoices


@apex_sdk.errorhandler
def HandleApplyButton():
    # Create a Dictionary to store the user defined tool data
    dictionary = {}

    dictionary["updateMaterial"] = updateMaterialToggle.IsChecked
    dictionary["updateDiameter"] = updateDiameterToggle.IsChecked

    choices = matlComboBox.SelectedValue.ToString().split(":")
    choice = choices[len(choices)-1].lstrip().rstrip()
    dictionary["material"] = choice

    dictionary["diameter"] = diameterTextBox.Text

    file_path = os.path.dirname(os.path.realpath(__file__))
    script_path= os.path.join(file_path, 'auUpdateFlexibleLinks.py')

    apex_sdk.runScriptFunction(script_path, "main", dictionary)


# exit button (red) from tool header
@apex_sdk.errorhandler
def HandleExitButton():
    print("HandleExitButton")


# This function receives data from the Script API function and updates the Tool UI
@apex_sdk.errorhandler
def getMatls():
    global matlComboBox

    ret_dict = apex_sdk.getScriptFunctionReturnData()

    matls = ret_dict["matlList"]

    updateComboBox(matlComboBox, matls)

